// Generated code
// run `make generate` to update

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"time"

	v1 "github.com/atlassian/voyager/pkg/apis/composition/v1"
	scheme "github.com/atlassian/voyager/pkg/composition/client/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ServiceDescriptorsGetter has a method to return a ServiceDescriptorInterface.
// A group's client should implement this interface.
type ServiceDescriptorsGetter interface {
	ServiceDescriptors() ServiceDescriptorInterface
}

// ServiceDescriptorInterface has methods to work with ServiceDescriptor resources.
type ServiceDescriptorInterface interface {
	Create(*v1.ServiceDescriptor) (*v1.ServiceDescriptor, error)
	Update(*v1.ServiceDescriptor) (*v1.ServiceDescriptor, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.ServiceDescriptor, error)
	List(opts metav1.ListOptions) (*v1.ServiceDescriptorList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.ServiceDescriptor, err error)
	ServiceDescriptorExpansion
}

// serviceDescriptors implements ServiceDescriptorInterface
type serviceDescriptors struct {
	client rest.Interface
}

// newServiceDescriptors returns a ServiceDescriptors
func newServiceDescriptors(c *CompositionV1Client) *serviceDescriptors {
	return &serviceDescriptors{
		client: c.RESTClient(),
	}
}

// Get takes name of the serviceDescriptor, and returns the corresponding serviceDescriptor object, and an error if there is any.
func (c *serviceDescriptors) Get(name string, options metav1.GetOptions) (result *v1.ServiceDescriptor, err error) {
	result = &v1.ServiceDescriptor{}
	err = c.client.Get().
		Resource("servicedescriptors").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ServiceDescriptors that match those selectors.
func (c *serviceDescriptors) List(opts metav1.ListOptions) (result *v1.ServiceDescriptorList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.ServiceDescriptorList{}
	err = c.client.Get().
		Resource("servicedescriptors").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested serviceDescriptors.
func (c *serviceDescriptors) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("servicedescriptors").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a serviceDescriptor and creates it.  Returns the server's representation of the serviceDescriptor, and an error, if there is any.
func (c *serviceDescriptors) Create(serviceDescriptor *v1.ServiceDescriptor) (result *v1.ServiceDescriptor, err error) {
	result = &v1.ServiceDescriptor{}
	err = c.client.Post().
		Resource("servicedescriptors").
		Body(serviceDescriptor).
		Do().
		Into(result)
	return
}

// Update takes the representation of a serviceDescriptor and updates it. Returns the server's representation of the serviceDescriptor, and an error, if there is any.
func (c *serviceDescriptors) Update(serviceDescriptor *v1.ServiceDescriptor) (result *v1.ServiceDescriptor, err error) {
	result = &v1.ServiceDescriptor{}
	err = c.client.Put().
		Resource("servicedescriptors").
		Name(serviceDescriptor.Name).
		Body(serviceDescriptor).
		Do().
		Into(result)
	return
}

// Delete takes name of the serviceDescriptor and deletes it. Returns an error if one occurs.
func (c *serviceDescriptors) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("servicedescriptors").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *serviceDescriptors) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("servicedescriptors").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched serviceDescriptor.
func (c *serviceDescriptors) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.ServiceDescriptor, err error) {
	result = &v1.ServiceDescriptor{}
	err = c.client.Patch(pt).
		Resource("servicedescriptors").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
