# Secret Parameter Plugin for Smith

This takes ServiceBindings or explicit Secret dependencies,
and converts them into a form acceptable to parametersFrom
in Service Catalog.

e.g. a ServiceBinding with a smith resource name of my-binding
produces a secret like so:

```
Secret:
  myVar: x
```

And with a plugin spec of:

```
plugin:
  spec:
    mapping:
      my-binding: # <-- name of Smith resource
        myVar: myComputeInputVar
```

we end up with:

Secret:
  my-binding: >
    {"myComputeInputVar": "x"}

This plugin will error out if the mapping is not possible in any
way (i.e. there is no `my-binding` amongst the dependencies,
OR there is no `myVar` in the secret generated by `my-binding`).

For a slightly more real example, see the examples directory.

## Running

This is run by adding it as a Smith plugin. See `cmd/smith/main.go`,
or run:

    make run-smith-sc-minikube
