// Generated code
// run `make generate` to update

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"time"

	v1 "github.com/atlassian/voyager/pkg/apis/orchestration/v1"
	scheme "github.com/atlassian/voyager/pkg/orchestration/client/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// StatesGetter has a method to return a StateInterface.
// A group's client should implement this interface.
type StatesGetter interface {
	States(namespace string) StateInterface
}

// StateInterface has methods to work with State resources.
type StateInterface interface {
	Create(*v1.State) (*v1.State, error)
	Update(*v1.State) (*v1.State, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.State, error)
	List(opts metav1.ListOptions) (*v1.StateList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.State, err error)
	StateExpansion
}

// states implements StateInterface
type states struct {
	client rest.Interface
	ns     string
}

// newStates returns a States
func newStates(c *OrchestrationV1Client, namespace string) *states {
	return &states{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the state, and returns the corresponding state object, and an error if there is any.
func (c *states) Get(name string, options metav1.GetOptions) (result *v1.State, err error) {
	result = &v1.State{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("states").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of States that match those selectors.
func (c *states) List(opts metav1.ListOptions) (result *v1.StateList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.StateList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("states").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested states.
func (c *states) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("states").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a state and creates it.  Returns the server's representation of the state, and an error, if there is any.
func (c *states) Create(state *v1.State) (result *v1.State, err error) {
	result = &v1.State{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("states").
		Body(state).
		Do().
		Into(result)
	return
}

// Update takes the representation of a state and updates it. Returns the server's representation of the state, and an error, if there is any.
func (c *states) Update(state *v1.State) (result *v1.State, err error) {
	result = &v1.State{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("states").
		Name(state.Name).
		Body(state).
		Do().
		Into(result)
	return
}

// Delete takes name of the state and deletes it. Returns an error if one occurs.
func (c *states) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("states").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *states) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("states").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched state.
func (c *states) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.State, err error) {
	result = &v1.State{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("states").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
