// Generated code
// run `make generate` to update

// Code generated by set-gen. DO NOT EDIT.

package sets

import (
	"reflect"
	"sort"

	voyager "github.com/atlassian/voyager"
)

// sets.ClusterLocation is a set of voyager.ClusterLocations, implemented via map[voyager.ClusterLocation]struct{} for minimal memory consumption.
type ClusterLocation map[voyager.ClusterLocation]Empty

// NewClusterLocation creates a ClusterLocation from a list of values.
func NewClusterLocation(items ...voyager.ClusterLocation) ClusterLocation {
	ss := ClusterLocation{}
	ss.Insert(items...)
	return ss
}

// ClusterLocationKeySet creates a ClusterLocation from a keys of a map[voyager.ClusterLocation](? extends interface{}).
// If the value passed in is not actually a map, this will panic.
func ClusterLocationKeySet(theMap interface{}) ClusterLocation {
	v := reflect.ValueOf(theMap)
	ret := ClusterLocation{}

	for _, keyValue := range v.MapKeys() {
		ret.Insert(keyValue.Interface().(voyager.ClusterLocation))
	}
	return ret
}

// Insert adds items to the set.
func (s ClusterLocation) Insert(items ...voyager.ClusterLocation) {
	for _, item := range items {
		s[item] = Empty{}
	}
}

// Delete removes all items from the set.
func (s ClusterLocation) Delete(items ...voyager.ClusterLocation) {
	for _, item := range items {
		delete(s, item)
	}
}

// Has returns true if and only if item is contained in the set.
func (s ClusterLocation) Has(item voyager.ClusterLocation) bool {
	_, contained := s[item]
	return contained
}

// HasAll returns true if and only if all items are contained in the set.
func (s ClusterLocation) HasAll(items ...voyager.ClusterLocation) bool {
	for _, item := range items {
		if !s.Has(item) {
			return false
		}
	}
	return true
}

// HasAny returns true if any items are contained in the set.
func (s ClusterLocation) HasAny(items ...voyager.ClusterLocation) bool {
	for _, item := range items {
		if s.Has(item) {
			return true
		}
	}
	return false
}

// Difference returns a set of objects that are not in s2
// For example:
// s1 = {a1, a2, a3}
// s2 = {a1, a2, a4, a5}
// s1.Difference(s2) = {a3}
// s2.Difference(s1) = {a4, a5}
func (s ClusterLocation) Difference(s2 ClusterLocation) ClusterLocation {
	result := NewClusterLocation()
	for key := range s {
		if !s2.Has(key) {
			result.Insert(key)
		}
	}
	return result
}

// Union returns a new set which includes items in either s1 or s2.
// For example:
// s1 = {a1, a2}
// s2 = {a3, a4}
// s1.Union(s2) = {a1, a2, a3, a4}
// s2.Union(s1) = {a1, a2, a3, a4}
func (s1 ClusterLocation) Union(s2 ClusterLocation) ClusterLocation {
	result := NewClusterLocation()
	for key := range s1 {
		result.Insert(key)
	}
	for key := range s2 {
		result.Insert(key)
	}
	return result
}

// Intersection returns a new set which includes the item in BOTH s1 and s2
// For example:
// s1 = {a1, a2}
// s2 = {a2, a3}
// s1.Intersection(s2) = {a2}
func (s1 ClusterLocation) Intersection(s2 ClusterLocation) ClusterLocation {
	var walk, other ClusterLocation
	result := NewClusterLocation()
	if s1.Len() < s2.Len() {
		walk = s1
		other = s2
	} else {
		walk = s2
		other = s1
	}
	for key := range walk {
		if other.Has(key) {
			result.Insert(key)
		}
	}
	return result
}

// IsSuperset returns true if and only if s1 is a superset of s2.
func (s1 ClusterLocation) IsSuperset(s2 ClusterLocation) bool {
	for item := range s2 {
		if !s1.Has(item) {
			return false
		}
	}
	return true
}

// Equal returns true if and only if s1 is equal (as a set) to s2.
// Two sets are equal if their membership is identical.
// (In practice, this means same elements, order doesn't matter)
func (s1 ClusterLocation) Equal(s2 ClusterLocation) bool {
	return len(s1) == len(s2) && s1.IsSuperset(s2)
}

type sortableSliceOfClusterLocation []voyager.ClusterLocation

func (s sortableSliceOfClusterLocation) Len() int           { return len(s) }
func (s sortableSliceOfClusterLocation) Less(i, j int) bool { return lessClusterLocation(s[i], s[j]) }
func (s sortableSliceOfClusterLocation) Swap(i, j int)      { s[i], s[j] = s[j], s[i] }

// List returns the contents as a sorted voyager.ClusterLocation slice.
func (s ClusterLocation) List() []voyager.ClusterLocation {
	res := make(sortableSliceOfClusterLocation, 0, len(s))
	for key := range s {
		res = append(res, key)
	}
	sort.Sort(res)
	return []voyager.ClusterLocation(res)
}

// UnsortedList returns the slice with contents in random order.
func (s ClusterLocation) UnsortedList() []voyager.ClusterLocation {
	res := make([]voyager.ClusterLocation, 0, len(s))
	for key := range s {
		res = append(res, key)
	}
	return res
}

// Returns a single element from the set.
func (s ClusterLocation) PopAny() (voyager.ClusterLocation, bool) {
	for key := range s {
		s.Delete(key)
		return key, true
	}
	var zeroValue voyager.ClusterLocation
	return zeroValue, false
}

// Len returns the size of the set.
func (s ClusterLocation) Len() int {
	return len(s)
}

func lessClusterLocation(lhs, rhs voyager.ClusterLocation) bool {
	if lhs.EnvType < rhs.EnvType {
		return true
	}
	if lhs.EnvType > rhs.EnvType {
		return false
	}
	if lhs.Account < rhs.Account {
		return true
	}
	if lhs.Account > rhs.Account {
		return false
	}
	if lhs.Region < rhs.Region {
		return true
	}
	if lhs.Region > rhs.Region {
		return false
	}
	return false
}
